/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_SYNTH_PLUCKED_H_
#define __GDAM_SYNTH_PLUCKED_H_


typedef struct _GdamSynthPlucked GdamSynthPlucked;
typedef struct _GdamSynthPluckedClass GdamSynthPluckedClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

GtkType gdam_synth_plucked_get_type();
#define GDAM_TYPE_SYNTH_PLUCKED			(gdam_synth_plucked_get_type ())
#define GDAM_SYNTH_PLUCKED(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_SYNTH_PLUCKED, GdamSynthPlucked))
#define GDAM_SYNTH_PLUCKED_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_SYNTH_PLUCKED, GdamSynthPluckedClass))
#define GDAM_IS_SYNTH_PLUCKED(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_SYNTH_PLUCKED))
#define GDAM_IS_SYNTH_PLUCKED_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_SYNTH_PLUCKED))

struct _GdamSynthPluckedClass {
	GdamSynthSourceClass		synth_plucked_class;
};
struct _GdamSynthPlucked {
	GdamSynthSource			synth_plucked;

	GdamSynthDelayLineAllPass*	delay_line;
	GdamSynthBuffer*		delay_line_in;

	GdamSynthDelayOneFir*		loop_filter;
	GdamSynthBuffer*		loop_filter_in;

	GdamSynthDelayOneIir*		pick_filter;
	GdamSynthBuffer*		pick_filter_in;

	GdamSynthNoise*			noise;

	int				length;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
